--- channels/chan_zap.dist.c	2006-08-23 20:14:22.160416000 +0200
+++ channels/chan_zap.c	2006-08-23 20:35:46.508007312 +0200
@@ -230,6 +230,8 @@
 static int immediate = 0;
 
 static int stripmsd = 0;
+static int stripnationalprefix = 1;
+static int stripinternationalprefix = 1;
 
 static int callwaiting = 0;
 
@@ -605,6 +607,8 @@
 	unsigned int setup_ack:1;
 #endif
 	unsigned int use_smdi:1;		/* Whether to use SMDI on this channel */
+	unsigned int stripnationalprefix:1;
+	unsigned int stripinternationalprefix:1;
 	struct ast_smdi_interface *smdi_iface;	/* The serial port to listen for SMDI data on */
 
 	struct zt_distRings drings;
@@ -2076,10 +2080,14 @@
  		pridialplan = p->pri->dialplan - 1;
  		if (pridialplan == -2) { /* compute dynamically */
  			if (strncmp(c + p->stripmsd, p->pri->internationalprefix, strlen(p->pri->internationalprefix)) == 0) {
- 				dp_strip = strlen(p->pri->internationalprefix);
+				if (p->stripinternationalprefix) {
+ 					dp_strip = strlen(p->pri->internationalprefix);
+				}
  				pridialplan = PRI_INTERNATIONAL_ISDN;
  			} else if (strncmp(c + p->stripmsd, p->pri->nationalprefix, strlen(p->pri->nationalprefix)) == 0) {
- 				dp_strip = strlen(p->pri->nationalprefix);
+				if (p->stripnationalprefix) {
+ 					dp_strip = strlen(p->pri->nationalprefix);
+				}
  				pridialplan = PRI_NATIONAL_ISDN;
  			} else {
 				pridialplan = PRI_LOCAL_ISDN;
@@ -2091,10 +2099,14 @@
 		prilocaldialplan = p->pri->localdialplan - 1;
 		if ((l != NULL) && (prilocaldialplan == -2)) { /* compute dynamically */
 			if (strncmp(l, p->pri->internationalprefix, strlen(p->pri->internationalprefix)) == 0) {
-				ldp_strip = strlen(p->pri->internationalprefix);
+				if (p->stripinternationalprefix) {
+					ldp_strip = strlen(p->pri->internationalprefix);
+				}
 				prilocaldialplan = PRI_INTERNATIONAL_ISDN;
 			} else if (strncmp(l, p->pri->nationalprefix, strlen(p->pri->nationalprefix)) == 0) {
-				ldp_strip = strlen(p->pri->nationalprefix);
+				if (p->stripnationalprefix) {
+					ldp_strip = strlen(p->pri->nationalprefix);
+				}
 				prilocaldialplan = PRI_NATIONAL_ISDN;
 			} else {
 				prilocaldialplan = PRI_LOCAL_ISDN;
@@ -7283,6 +7295,8 @@
 		tmp->hidecallerid = tmp->permhidecallerid;
 		tmp->channel = channel;
 		tmp->stripmsd = stripmsd;
+		tmp->stripnationalprefix = stripnationalprefix;
+		tmp->stripinternationalprefix = stripinternationalprefix;
 		tmp->use_callerid = use_callerid;
 		tmp->cid_signalling = cid_signalling;
 		tmp->cid_start = cid_start;
@@ -8121,10 +8135,18 @@
 {
 	switch (plan) {
 	case PRI_INTERNATIONAL_ISDN:		/* Q.931 dialplan == 0x11 international dialplan => prepend international prefix digits */
-		snprintf(buf, size, "%s%s", pri->internationalprefix, number);
+		if (stripinternationalprefix > 0) {
+			snprintf(buf, size, "%s%s", pri->internationalprefix, number);
+		} else {
+			snprintf(buf, size, "%s", number);
+		}
 		break;
 	case PRI_NATIONAL_ISDN:			/* Q.931 dialplan == 0x21 national dialplan => prepend national prefix digits */
-		snprintf(buf, size, "%s%s", pri->nationalprefix, number);
+		if (stripnationalprefix > 0) {
+			snprintf(buf, size, "%s%s", pri->nationalprefix, number);
+		} else {
+			snprintf(buf, size, "%s", number);
+		}
 		break;
 	case PRI_LOCAL_ISDN:			/* Q.931 dialplan == 0x41 local dialplan => prepend local prefix digits */
 		snprintf(buf, size, "%s%s", pri->localprefix, number);
@@ -10554,6 +10576,10 @@
 			ast_copy_string(mohsuggest, v->value, sizeof(mohsuggest));
 		} else if (!strcasecmp(v->name, "stripmsd")) {
 			stripmsd = atoi(v->value);
+		} else if (!strcasecmp(v->name, "stripnationalprefix")) {
+			stripnationalprefix = ast_true(v->value);
+		} else if (!strcasecmp(v->name, "stripinternationalprefix")) {
+			stripinternationalprefix = ast_true(v->value);
 		} else if (!strcasecmp(v->name, "jitterbuffers")) {
 			numbufs = atoi(v->value);
 		} else if (!strcasecmp(v->name, "group")) {
